From 2277378131c3ad395822b1a5c67f70deac1fd3ec Mon Sep 17 00:00:00 2001
From: Ilya Shpigor <shpigor@etersoft.ru>
Date: Thu, 19 Mar 2009 15:50:20 +0300
Subject: [PATCH] gdi32/tests: Add test to StretchBlt for dibengine

---
 dlls/gdi32/tests/dib.c |   54 ++++++++++++++++++++++++++++++++++++++++++++++++
 1 files changed, 54 insertions(+), 0 deletions(-)

diff --git a/dlls/gdi32/tests/dib.c b/dlls/gdi32/tests/dib.c
index 90f92d9..5a2057a 100644
--- a/dlls/gdi32/tests/dib.c
+++ b/dlls/gdi32/tests/dib.c
@@ -367,8 +367,62 @@ static void test_ArcTo_SolidPen()
     DeleteDC(memDC);
 }
 
+/*
+    test StretchBlt
+*/
+static void test_StretchBlt()
+{
+    HWND hwnd;
+    HDC memdc, dc;
+    HBITMAP membmp;
+    WNDCLASSA cls;
+    char bmibuf[sizeof(BITMAPINFO) + 256 * sizeof(RGBQUAD)];
+    BITMAPINFO *bmi;
+    BYTE *bits;
+
+    cls.style = CS_DBLCLKS;
+    cls.lpfnWndProc = DefWindowProcA;
+    cls.cbClsExtra = 0;
+    cls.cbWndExtra = 0;
+    cls.hInstance = GetModuleHandleA(0);
+    cls.hIcon = 0;
+    cls.hCursor = LoadCursorA(0, IDC_ARROW);
+    cls.hbrBackground = GetStockObject(WHITE_BRUSH);
+    cls.lpszMenuName = NULL;
+    cls.lpszClassName = "WinClass";
+
+    if(!RegisterClassA(&cls)) return;
+
+    memdc = CreateCompatibleDC(NULL);
+
+    bmi = (BITMAPINFO* ) bmibuf;
+    memset(bmi, 0, sizeof(bmibuf));
+
+    bmi->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
+        bmi->bmiHeader.biHeight =  100;
+        bmi->bmiHeader.biWidth =  100;
+        bmi->bmiHeader.biPlanes = 1;
+        bmi->bmiHeader.biBitCount = 24;
+        bmi->bmiHeader.biCompression = BI_RGB;
+        bmi->bmiHeader.biSizeImage = bmi->bmiHeader.biHeight * bmi->bmiHeader.biWidth * 4;
+
+    membmp = CreateDIBSection(memdc, bmi, DIB_RGB_COLORS,(void**)&bits,0,0);
+
+    if (!memdc || !membmp) return;
+
+    SelectObject( memdc, membmp );
+
+    hwnd = CreateWindowExA(0, "WinClass", "Test windows", WS_OVERLAPPEDWINDOW | WS_VISIBLE, 0, 0, 200, 200, 0, 0, 0, NULL);
+
+    dc = GetDC(hwnd);
+    ok(StretchBlt(dc, 0, 0, 200, 200, memdc, 0, 0, 100, 100, SRCCOPY), "StretchBlt return 0\n");
+
+    DestroyWindow(hwnd);
+    UnregisterClass("WinClass", GetModuleHandle(0));
+}
 
 START_TEST(dib)
 {
+    test_StretchBlt();
     test_Polyline_SolidPen();
 }
-- 
1.6.1.3.GIT

